=== debian/changelog ===
spades (4.0.0+dfsg1-1) experimental; urgency=medium

  * Team upload
  * New upstream version 4.0.0+dfsg1
  * Refreshing patches
  * Raising Standards version to 4.7.0 (no change)
  * Rewriting d/copyright
  * Changing the paths of the files to remove when repacking
  * Updating the list of files to exclude when repacking
  * Updating files related to shipped doc in the debian/ directory
  * Removing the now useless override of dh_installchangelogs
  * Using bamtools, googletest, spoa, boost, cuckoo, joblib and xxhash from the
    Debian packages instead of embedded copies, updating d/control accordingly
  * Updating paths in d/rules
  * Adding missing files to the CMakeLists.txt file of the samtools part
  * Deactivating build-time tests of which test data have vanished from the
    source package
  * Updating homepage URI
  * Removing obsolete Lintian override for source-is-missing
  * Adding a Lintian override for the embedded (modified) copy of Zlib

 -- Pierre Gruet <pgt@debian.org>  Wed, 02 Oct 2024 08:56:41 +0200
