=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1

include /usr/share/dpkg/default.mk

mandir     := $(CURDIR)/debian/man
debfolder  := $(CURDIR)/debian

export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=-lto
export LC_ALL = C

%:
	dh $@ --sourcedirectory=src --buildsystem=cmake

override_dh_clean:
	dh_clean -X.orig

override_dh_auto_clean:
	dh_auto_clean
	find . -name "*.pyc" -delete
	rm -rf $(debfolder)/man_src/*.html $(debfolder)/man_src/*.?
	rm -rf $(mandir)

override_dh_auto_configure:
	dh_auto_configure -- -DBoost_NO_BOOST_CMAKE=TRUE -DSPADES_BOOST_ROOT:PATH="/usr"

override_dh_auto_build:
	dh_auto_build -- all debruijn_test include_test

execute_after_dh_auto_install:
	# Use Debian-packaged yaml module
	find debian/spades \
		-type f \
		-exec sed -i 's/pyyaml[2|3]/yaml/' {} +

	mkdir -p debian/$(DEB_SOURCE)/usr/libexec/spades/
	mv debian/$(DEB_SOURCE)/usr/bin/* debian/$(DEB_SOURCE)/usr/libexec/spades/

	rm -f debian/$(DEB_SOURCE)/usr/share/spades/*.html
	rm -f debian/$(DEB_SOURCE)/usr/share/spades/manual.md
	rm -f debian/$(DEB_SOURCE)/usr/share/spades/GPLv2.txt
	rm -f debian/$(DEB_SOURCE)/usr/share/spades/README.md
	rm -f debian/$(DEB_SOURCE)/usr/share/spades/LICENSE

override_dh_installman:
	mkdir -p $(mandir)
	asciidoctor -a docdate='' -b manpage $(debfolder)/man_src/*.adoc
	cp $(debfolder)/man_src/*.? $(mandir)
	dh_installman
